#include <iostream>
#include <vector>
#include <stdio.h>  
#include <stdlib.h>
#include <queue>
using namespace std;
 
int n, p, k, x;
 
struct  Edge{
    int v;
    bool is_extra;
 
    Edge(int vv, bool extra = false) {
        v = vv;
        is_extra = extra;
    }
 
};
 
vector<vector<Edge> > g;
 
vector<int> vis;
vector<int> d;
 
 
void bfs(int x) {
     
    queue<int> q;
	q.push(x);
	vis[x] = true;
	d[x] = 0;
	
	while(!q.empty()) {
        int v = q.front();
        q.pop();
         
        for(int i = 0; i < g[v].size(); ++i) {
            Edge to = g[v][i];
 
            if (!vis[to.v]) {
                if (to.is_extra) continue;
 
                vis[to.v] = true;
                d[to.v] = d[v] + 1;
                q.push(to.v);
            }
        }
    }
		
}
 
int main()
{
     
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
     
    cin >> n >> p >> k >> x;
 
    g.resize(n);
 
    for(int i = 0; i < n-1; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(Edge(v));
        g[v].push_back(Edge(u));
    }
 
    for(int i = 0; i < p; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(Edge(v, true));
        g[v].push_back(Edge(u, true));
    }
 
    vis.resize(n);
    d.resize(n);
    int yy, mm = 0;
    bfs(0);
    for(int i = 0; i < n; ++i) {
        vis[i] = false;
        if (mm < d[i]) {
            mm = d[i];
            yy = i;
        }
        d[i] = 0;
    }
 
 
    queue<int> q;
    q.push(x - 1);
    int extra_used = 0;
    d[x-1] = 0;
 
    while(!q.empty()) {
        if (x-1 == yy) break;
 
        int v = q.front();
        q.pop();
         
        for(int i = 0; i < g[v].size(); ++i) {
            Edge to = g[v][i];
 
            if (!vis[to.v]) {
                if (to.is_extra && extra_used >= k) continue;
 
                vis[to.v] = true;
                d[to.v] = d[v] + 1;
                extra_used += to.is_extra;
                q.push(to.v);
            }
 
            if (to.v == yy)
                break;
        }
    }
 
    cout << d[yy];
}